Index: pacemaker/pengine/test10/failcount.exp
===================================================================
--- pacemaker.orig/pengine/test10/failcount.exp
+++ pacemaker/pengine/test10/failcount.exp
@@ -3,7 +3,7 @@
     <action_set>
       <crm_event id="7" operation="clear_failcount" operation_key="re-openfire-lsb:0_clear_failcount" on_node="dresproddns01" on_node_uuid="dresproddns01">
         <primitive id="re-openfire-lsb" long-id="re-openfire-lsb:0" class="lsb" type="openfire"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_no_wait="true" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dresproddns01" CRM_meta_on_node_uuid="dresproddns01" CRM_meta_op_no_wait="true" CRM_meta_timeout="20000" />
       </crm_event>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <crm_event id="32" operation="clear_failcount" operation_key="re-openfire-lsb:1_clear_failcount" on_node="dresproddns02" on_node_uuid="dresproddns02">
         <primitive id="re-openfire-lsb" long-id="re-openfire-lsb:1" class="lsb" type="openfire"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_no_wait="true" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dresproddns02" CRM_meta_on_node_uuid="dresproddns02" CRM_meta_op_no_wait="true" CRM_meta_timeout="20000" />
       </crm_event>
     </action_set>
     <inputs/>
@@ -21,7 +21,7 @@
     <action_set>
       <rsc_op id="4" operation="monitor" operation_key="re-named-lsb:1_monitor_10000" internal_operation_key="re-named-lsb:0_monitor_10000" on_node="dresproddns01" on_node_uuid="dresproddns01">
         <primitive id="re-named-lsb" long-id="re-named-lsb:1" class="lsb" type="named"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="5000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="dresproddns01" CRM_meta_on_node_uuid="dresproddns01" CRM_meta_timeout="5000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -30,7 +30,7 @@
     <action_set>
       <rsc_op id="28" operation="monitor" operation_key="re-named-lsb:0_monitor_10000" internal_operation_key="re-named-lsb:1_monitor_10000" on_node="dresproddns02" on_node_uuid="dresproddns02">
         <primitive id="re-named-lsb" long-id="re-named-lsb:0" class="lsb" type="named"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="5000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="dresproddns02" CRM_meta_on_node_uuid="dresproddns02" CRM_meta_timeout="5000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/group-fail.exp
===================================================================
--- pacemaker.orig/pengine/test10/group-fail.exp
+++ pacemaker/pengine/test10/group-fail.exp
@@ -65,7 +65,7 @@
     <action_set>
       <rsc_op id="2" operation="start" operation_key="rsc1_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -78,7 +78,7 @@
     <action_set>
       <rsc_op id="4" operation="start" operation_key="rsc2_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -97,7 +97,7 @@
     <action_set>
       <rsc_op id="3" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -113,7 +113,7 @@
     <action_set>
       <rsc_op id="5" operation="start" operation_key="rsc3_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -129,7 +129,7 @@
     <action_set>
       <rsc_op id="7" operation="start" operation_key="rsc4_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -148,7 +148,7 @@
     <action_set>
       <rsc_op id="6" operation="stop" operation_key="rsc4_stop_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc4" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/group-unmanaged-stopped.exp
===================================================================
--- pacemaker.orig/pengine/test10/group-unmanaged-stopped.exp
+++ pacemaker/pengine/test10/group-unmanaged-stopped.exp
@@ -26,7 +26,7 @@
     <action_set>
       <rsc_op id="8" operation="stop" operation_key="r192.168.122.115_stop_0" on_node="pcmk-1" on_node_uuid="1">
         <primitive id="r192.168.122.115" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.115"/>
+        <attributes CRM_meta_on_node="pcmk-1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.115"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/group1.exp
===================================================================
--- pacemaker.orig/pengine/test10/group1.exp
+++ pacemaker/pengine/test10/group1.exp
@@ -32,7 +32,7 @@
      <action_set>
       <rsc_op id="8" operation="start" operation_key="child_rsc1_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="child_rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -51,7 +51,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="child_rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="child_rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -60,7 +60,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="child_rsc1_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="child_rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -69,7 +69,7 @@
      <action_set>
       <rsc_op id="9" operation="start" operation_key="child_rsc2_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="child_rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -91,7 +91,7 @@
      <action_set>
       <rsc_op id="6" operation="monitor" operation_key="child_rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="child_rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -100,7 +100,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="child_rsc2_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="child_rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -109,7 +109,7 @@
      <action_set>
       <rsc_op id="10" operation="start" operation_key="child_rsc3_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="child_rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -131,7 +131,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="child_rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="child_rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -140,7 +140,7 @@
     <action_set>
       <rsc_op id="4" operation="monitor" operation_key="child_rsc3_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="child_rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/group10.exp
===================================================================
--- pacemaker.orig/pengine/test10/group10.exp
+++ pacemaker/pengine/test10/group10.exp
@@ -65,7 +65,7 @@
      <action_set>
       <rsc_op id="26" operation="start" operation_key="child_192.168.100.181_start_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.181" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="192.168.100.181"/>
+        <attributes CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.181"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -81,7 +81,7 @@
      <action_set>
        <rsc_op id="13" operation="stop" operation_key="child_192.168.100.181_stop_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.181" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="192.168.100.181"/>
+        <attributes CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.181"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -97,7 +97,7 @@
      <action_set>
       <rsc_op id="12" operation="monitor" operation_key="child_192.168.100.181_monitor_5000" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.181" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  ip="192.168.100.181"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.181"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -110,7 +110,7 @@
      <action_set>
       <rsc_op id="28" operation="start" operation_key="child_192.168.100.182_start_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.182" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="192.168.100.182"/>
+        <attributes CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.182"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -129,7 +129,7 @@
      <action_set>
       <rsc_op id="27" operation="stop" operation_key="child_192.168.100.182_stop_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.182" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="192.168.100.182"/>
+        <attributes CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.182"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -145,7 +145,7 @@
      <action_set>
       <rsc_op id="9" operation="monitor" operation_key="child_192.168.100.182_monitor_5000" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.182" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  ip="192.168.100.182"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.182"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -158,7 +158,7 @@
      <action_set>
       <rsc_op id="30" operation="start" operation_key="child_192.168.100.183_start_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.183" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="192.168.100.183"/>
+        <attributes CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.183"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -177,7 +177,7 @@
      <action_set>
       <rsc_op id="29" operation="stop" operation_key="child_192.168.100.183_stop_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.183" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="20000"  ip="192.168.100.183"/>
+        <attributes CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.183"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -190,7 +190,7 @@
      <action_set>
       <rsc_op id="11" operation="monitor" operation_key="child_192.168.100.183_monitor_5000" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_192.168.100.183" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  ip="192.168.100.183"/>
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_timeout="20000"  ip="192.168.100.183"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -203,7 +203,7 @@
      <action_set>
       <rsc_op id="22" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b">
         <primitive id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n08" CRM_meta_on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -212,7 +212,7 @@
      <action_set>
       <rsc_op id="20" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193">
         <primitive id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n03" CRM_meta_on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -221,7 +221,7 @@
      <action_set>
       <rsc_op id="15" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -230,7 +230,7 @@
      <action_set>
       <rsc_op id="23" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n08" CRM_meta_on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -239,7 +239,7 @@
      <action_set>
       <rsc_op id="18" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="c001n02" on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n02" CRM_meta_on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -248,7 +248,7 @@
      <action_set>
       <rsc_op id="16" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_DoFencing:2" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -257,7 +257,7 @@
      <action_set>
       <rsc_op id="21" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193">
         <primitive id="child_DoFencing:3" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n03" CRM_meta_on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -266,7 +266,7 @@
      <action_set>
       <rsc_op id="19" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="c001n02" on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f">
         <primitive id="child_DoFencing:3" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n02" CRM_meta_on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
@@ -275,7 +275,7 @@
      <action_set>
       <rsc_op id="17" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3">
         <primitive id="child_DoFencing:3" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
+        <attributes CRM_meta_clone="3" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="true" CRM_meta_notify="false" CRM_meta_on_node="c001n01" CRM_meta_on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  hostlist="c001n08 c001n02 c001n03 c001n01 "/>
        </rsc_op>
      </action_set>
      <inputs/>
Index: pacemaker/pengine/test10/group11.exp
===================================================================
--- pacemaker.orig/pengine/test10/group11.exp
+++ pacemaker/pengine/test10/group11.exp
@@ -41,7 +41,7 @@
      <action_set>
       <rsc_op id="5" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000"  target_role="Stopped"/>
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000"  target_role="Stopped"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -57,7 +57,7 @@
      <action_set>
       <rsc_op id="6" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000"  target_role="started"/>
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000"  target_role="started"/>
        </rsc_op>
      </action_set>
      <inputs>
Index: pacemaker/pengine/test10/group13.exp
===================================================================
--- pacemaker.orig/pengine/test10/group13.exp
+++ pacemaker/pengine/test10/group13.exp
@@ -26,7 +26,7 @@
      <action_set>
       <rsc_op id="2" operation="stop" operation_key="resource_nfs_stop_0" on_node="jamesltc" on_node_uuid="cd13842c-3f58-4e7d-8126-685259527532">
         <primitive id="resource_nfs" class="lsb" type="nfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="jamesltc" CRM_meta_on_node_uuid="cd13842c-3f58-4e7d-8126-685259527532" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
Index: pacemaker/pengine/test10/group14.exp
===================================================================
--- pacemaker.orig/pengine/test10/group14.exp
+++ pacemaker/pengine/test10/group14.exp
@@ -38,7 +38,7 @@
      <action_set>
       <rsc_op id="5" operation="stop" operation_key="r192.168.100.181_stop_0" on_node="c001n06" on_node_uuid="169e4673-93fb-4c0a-8082-d3408bae9431">
         <primitive id="r192.168.100.181" class="ocf" provider="heartbeat" type="IPaddr"/>
-        <attributes CRM_meta_timeout="10000"  ip="192.168.100.181"/>
+        <attributes CRM_meta_on_node="c001n06" CRM_meta_on_node_uuid="169e4673-93fb-4c0a-8082-d3408bae9431" CRM_meta_timeout="10000"  ip="192.168.100.181"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -51,7 +51,7 @@
      <action_set>
       <rsc_op id="33" operation="monitor" operation_key="child_DoFencing:0_monitor_20000" on_node="c001n06" on_node_uuid="169e4673-93fb-4c0a-8082-d3408bae9431">
         <primitive id="child_DoFencing" long-id="child_DoFencing:0" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="c001n06" CRM_meta_on_node_uuid="169e4673-93fb-4c0a-8082-d3408bae9431" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -64,7 +64,7 @@
      <action_set>
       <rsc_op id="32" operation="start" operation_key="child_DoFencing:0_start_0" on_node="c001n06" on_node_uuid="169e4673-93fb-4c0a-8082-d3408bae9431">
         <primitive id="child_DoFencing" long-id="child_DoFencing:0" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="start" CRM_meta_notify="false" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="start" CRM_meta_notify="false" CRM_meta_on_node="c001n06" CRM_meta_on_node_uuid="169e4673-93fb-4c0a-8082-d3408bae9431" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -77,7 +77,7 @@
      <action_set>
       <rsc_op id="35" operation="monitor" operation_key="child_DoFencing:1_monitor_20000" on_node="c001n07" on_node_uuid="6637ebb5-ab11-4728-b69e-b61222af9a0c">
         <primitive id="child_DoFencing" long-id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="c001n07" CRM_meta_on_node_uuid="6637ebb5-ab11-4728-b69e-b61222af9a0c" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -90,7 +90,7 @@
      <action_set>
       <rsc_op id="34" operation="start" operation_key="child_DoFencing:1_start_0" on_node="c001n07" on_node_uuid="6637ebb5-ab11-4728-b69e-b61222af9a0c">
         <primitive id="child_DoFencing" long-id="child_DoFencing:1" class="stonith" type="ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="start" CRM_meta_notify="false" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="start" CRM_meta_notify="false" CRM_meta_on_node="c001n07" CRM_meta_on_node_uuid="6637ebb5-ab11-4728-b69e-b61222af9a0c" CRM_meta_requires="nothing" CRM_meta_timeout="10000"  hostlist="c001n03 c001n02 c001n04 c001n05 c001n06 c001n07 "/>
        </rsc_op>
      </action_set>
      <inputs>
